/*
**      Small-C Preprocessor Ver 1.0  - 01-Nov-87 - cpp7.c
**
**      Copyright 1982, J. E. Hendrix
**
*/

#include        "cpp.h"

char
        macn[MACNSIZE],         /* macro name buffer */
        macq[MACQSIZE],         /* macro string buffer */
        pline1[LINESIZE],       /* parsing buffer */
        pline2[LINESIZE],       /* parsing buffer */
        mline[LINESIZE],        /* macro buffer */
        *iline,                 /* points to a line buffer */
        *oline,                 /* points to a line buffer */
        *lptr,                  /* ptr to either */
        *glbptr,                /* ptrs to next entries */
        *locptr,                /* ptr to next local symbol */
        quote[2],               /* literal string for '"' */
        *cptr,                  /* work ptrs to any char buffer */
        *cptr2,
        *cptr3,
        msname[NAMESIZE],       /* macro symbol name array */
        ssname[NAMESIZE],       /* static symbol name array */
        xc,                     /* work char */
        *xcp;                   /* work char ptr */

int
        macptr,                 /* macro buffer index */
        ocount,                 /* count of output characters */
        ch,                     /* current character of line being scanned */
        nch,                    /* next character of line being scanned */
        iflevel,                /* #if... nest level */
        skiplevel,              /* level at which #if... skipping started */
        argstk,                 /* function argument sp */
        argtop,
        errflag,                /* non-zero after 1st error in statement */
        eof,                    /* set non-zero after final input eof */
        files,                  /* != 0 if file list specified on cmd line*/
        filearg,                /* current file arg index */
        ctext,                  /* non-zero to intermix c-source */
        ccode,                  /* non-zero when parsing c-code */
                                /* zero when parsing assembly code */
        contin,                 /* last char of line == \      */
        ppline,                 /* first char of line == #     */
        instring,               /* within a string             */
        incomment,              /* within a comment            */
        enstring,
        encomment,
        xi,                     /* work int */
        *xip;                   /* work int ptr */

FILE
    **input,                 /* file pointer for input file */
    *fileptr[12],            /* array of open file pointers */
    *output,                 /* file pointer for output file */
    *listfp;                 /* file pointer to list device */

